#!/bin/sh
# Copyright start
# Copyright (C) 2008 - 2024 Fortinet Inc.
# All rights reserved.
# FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
# Copyright end

CELERYD_CONF=/etc/celery/celeryd.conf
SEALAB_WSGI_INI=/etc/uwsgi.d/sealab_wsgi.ini
INTEGRATIONS_WSGI_INI=/etc/uwsgi.d/integrations_wsgi.ini
CYOPS_API_CONF=/etc/php-fpm.d/cyops-api.conf
RABBITMQ_ENV_CONF=/etc/rabbitmq/rabbitmq-env.conf

number_of_available_processing_units=$(nproc)
half_num_avail_processing_units=$(( $number_of_available_processing_units/2 ))
celeryd_autoscale_min=$number_of_available_processing_units
celeryd_autoscale_max=$(( $celeryd_autoscale_min + 4 ))

update_application_configurations(){
    if [ $number_of_available_processing_units -gt 8 ]; then
        sed -i "/CELERYD_OPTS=\"--autoscale=/c\\CELERYD_OPTS=\"--autoscale=$celeryd_autoscale_max,$celeryd_autoscale_min\"" $CELERYD_CONF
        sed -i "/pm.start_servers/c\pm.start_servers = $number_of_available_processing_units" $CYOPS_API_CONF
        sed -i "/pm.max_spare_servers/c\pm.max_spare_servers = $number_of_available_processing_units" $CYOPS_API_CONF
        sed -i "/RABBITMQ_SERVER_ADDITIONAL_ERL_ARGS/c\RABBITMQ_SERVER_ADDITIONAL_ERL_ARGS=\"+S $half_num_avail_processing_units:$half_num_avail_processing_units\"" $RABBITMQ_ENV_CONF
    fi
    if [ $number_of_available_processing_units -gt 10 ]; then
        sed -i "/processes/c\processes = $number_of_available_processing_units" $SEALAB_WSGI_INI
        sed -i "/processes/c\processes = $number_of_available_processing_units" $INTEGRATIONS_WSGI_INI
    fi
}

update_application_configurations